"""
Django settings for aguila project.

Generated by 'django-admin startproject' using Django 2.2.8.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import os
from os.path import dirname, abspath, join
from datetime import timedelta
from pathlib import Path
from dotenv import load_dotenv
from . import get_env_variable

env_path = str(Path('.') / '.env')
load_dotenv(dotenv_path=env_path)


# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
# BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

BASE_DIR = dirname(dirname(dirname(abspath(__file__))))#eso fue modificado
ENDPOINT = join(BASE_DIR,'Endpoint/Crudos/')
MIX = join(BASE_DIR,'Endpoint/Mix/')

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = get_env_variable('SECRET_KEY')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = get_env_variable('DEBUG')

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    'config.utils.suit.SuitConfig',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

    #=== Librerías de Terceros ===#
    'rest_framework',
    'rest_framework_swagger',
    'django_datatables_view',
    'simple_history',

    #=== Librerías Propias ===#

    'users.apps.UsersConfig',#usuarios
    'general.apps.GeneralConfig',#frontend
    'customers.apps.CustomersConfig',
    'finances.apps.FinancesConfig',

    
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'simple_history.middleware.HistoryRequestMiddleware',
]

ROOT_URLCONF = 'config.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [join(BASE_DIR,'templates/')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'config.wsgi.application'


# Database
# https://docs.djangoproject.com/en/2.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql',
        'NAME': get_env_variable('DB_NAME'),
        'PASSWORD': get_env_variable('DB_PASSWORD'),
        'USER': get_env_variable('DB_USER'),
        'HOST': get_env_variable('DB_HOST'),
        'PORT': get_env_variable('DB_PORT')
    }
}


# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'es-cl'

TIME_ZONE = 'America/Santiago'

USE_I18N = True

USE_L10N = True

USE_TZ = True

USE_THOUSAND_SEPARATOR = True


FORMAT_MODULE_PATH = [
    'config.format_number.formats',
]


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = 'static'

STATICFILES_DIRS = [
    os.path.join(BASE_DIR,'staticfiles/')
]


REST_FRAMEWORK = {
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.IsAuthenticated',#  AllowAny
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_jwt.authentication.JSONWebTokenAuthentication',
    ),
    'DEFAULT_FILTER_BACKENDS': [
        'url_filter.integrations.drf.DjangoFilterBackend',
    ],    
    'DEFAULT_VERSIONING_CLASS': 'rest_framework.versioning.URLPathVersioning',    
    'DEFAULT_PAGINATION_CLASS': 'config.utils.pagination.LinkHeaderPagination',
    'PAGE_SIZE': 100,
    'DEFAULT_THROTTLE_CLASSES': (
        'rest_framework.throttling.AnonRateThrottle',
        'rest_framework.throttling.UserRateThrottle'
    ),
    'NUM_PROXIES': 2,
    'DEFAULT_THROTTLE_RATES': {
        'anon': '100/hour',
        'user': '700/hour'
    },
    #token
    'JWT_EXPIRATION_DELTA': timedelta(hours=48),
    "JWT_ALLOW_REFRESH": True,

}


SWAGGER_SETTINGS = {
    'SECURITY_DEFINITIONS': {
        'api_key': {
            'type': 'apiKey',
            'in': 'header',
            'name': 'Authorization'
        }
    },
    'USE_SESSION_AUTH': False
}


AUTHENTICATION_BACKENDS = ['config.utils.backends.EmailAuthBackend','django.contrib.auth.backends.ModelBackend']

#########################
    ## DEL SISTEMA ##
#########################

SITE_NAME = "aguila"
CSRF_COOKIE_NAME = 'csrftoken_' + SITE_NAME
SESSION_COOKIE_NAME = 'scn_' + SITE_NAME
NAME_JWT = 'tok_' + SITE_NAME

LOGIN_REDIRECT_URL = '/'
LOGIN_URL = '/login/'